package cn.iocoder.yudao.module.mes.service.zjtype;

import cn.hutool.core.collection.CollUtil;
import cn.iocoder.yudao.module.iot.dal.dataobject.deviceattributetype.DeviceAttributeTypeDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.deviceledger.DeviceLedgerDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.zjitem.ZjItemDO;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.mes.controller.admin.zjtype.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.zjtype.ZjTypeDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.mes.dal.mysql.zjtype.ZjTypeMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;

/**
 * 质量管理-检验类型 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class ZjTypeServiceImpl implements ZjTypeService {

    @Resource
    private ZjTypeMapper zjTypeMapper;

    @Override
    public Long createZjType(ZjTypeSaveReqVO createReqVO) {
        // 校验编码是否存在
        validateCodeOnly(createReqVO.getCode());
        // 插入
        ZjTypeDO zjType = BeanUtils.toBean(createReqVO, ZjTypeDO.class);
        zjTypeMapper.insert(zjType);
        // 返回
        return zjType.getId();
    }
    private void validateCodeOnly(String code) {
        if (zjTypeMapper.exists(Wrappers.<ZjTypeDO>lambdaQuery()
                .eq(ZjTypeDO::getCode, code))) {
            throw exception(ZJ_TYPE_CODE_EXISTS);
        }
    }

    @Override
    public void updateZjType(ZjTypeSaveReqVO updateReqVO) {
        // 校验存在
        validateZjTypeExists(updateReqVO.getId());
        // 更新
        ZjTypeDO updateObj = BeanUtils.toBean(updateReqVO, ZjTypeDO.class);
        zjTypeMapper.updateById(updateObj);
    }

    @Override
    public void deleteZjType(Long id) {
        // 校验存在
        validateZjTypeExists(id);
        // 删除
        zjTypeMapper.deleteById(id);
    }

    private void validateZjTypeExists(Long id) {
        if (zjTypeMapper.selectById(id) == null) {
            throw exception(ZJ_TYPE_NOT_EXISTS);
        }
    }

    @Override
    public ZjTypeDO getZjType(Long id) {
        return zjTypeMapper.selectById(id);
    }

    @Override
    public PageResult<ZjTypeDO> getZjTypePage(ZjTypePageReqVO pageReqVO) {
        return zjTypeMapper.selectPage(pageReqVO);
    }

    @Override
    public List<ZjTypeDO> getZjTypeList() {
        return zjTypeMapper.selectList();
    }

    @Override
    public List<ZjTypeDO> getZjTypeVOList(Collection<Long> ids) {
        if (CollUtil.isEmpty(ids)) {
            return Collections.emptyList();
        }
        return(zjTypeMapper.selectBatchIds(ids));
    }
}